/* 2002/12/31
 *
 * bitonic.c - uoCgjbN\[gv
 *
 * Presented by YUTAKA
 */
#include <stdio.h>

#define MAX 8         /* f[^(2̗ݏł邱) */
#define ASC_DIR 1      /* (ascending) */
#define DES_DIR 0      /* ~(descending) */

void show_data(int *data, int num)
{
	int i;

	for (i = 0 ; i < num ; i++) {
		printf("%d ", data[i]);
	}
	printf("\n");
}

/* oCgjbN}[W\[g */
void bitonic_merge(int *data, int low, int num, int dir)
{
	int mid, i, t;

	if (num < 2) 
		return;

	/*
	 * oCgjbN a1,a2caNca2N ɑ΂āC
	 * ai  aN+i (1iN) ̑召rB
	 *
	 * di = min(ai, aN+i) 
	 * ci = max(ai, aN+i)
	 * `ƂC di  ci oCgjbNɂȂB
	 */
	mid = num / 2;
	for (i = low ; i < low + mid ; i++) {
		if ((data[i] > data[i + mid]) == dir) {
			t = data[i];
			data[i] = data[i + mid];
			data[i + mid] = t;
		}
	}

	bitonic_merge(data, low, mid, dir);
	bitonic_merge(data, low + mid, mid, dir);
}

/* ɂoCgjbN */
void bitonic_sort(int *data, int low, int num, int dir)
{
	int mid;

	if (num < 2) 
		return;

	mid = num / 2;
	bitonic_sort(data, low, mid, ASC_DIR);        /* Ƀ\[g */
	bitonic_sort(data, low + mid, mid, DES_DIR);  /* ~Ƀ\[g */
	bitonic_merge(data, low, num, dir);   /* }[W */
	show_data(data, MAX); 
}

/* C֐ */
int main(void)
{
	/* f[^ */
	int data[MAX] = {30,19,7,24,26,14, 5, 1};

	printf("сF");
	show_data(data, MAX);

	bitonic_sort(data, 0, MAX, ASC_DIR);

	printf("F");
	show_data(data, MAX);

	return 0;
}


