/*
 * stack.c - uX^bNv
 *
 */
#include <stdio.h>

#define MAX 100
int stack[MAX];
int sp = 0;

void show(void)
{
	int i;

	printf("|-----|\n");
	for (i = sp - 1; i >= 0 ; i--) {
		printf("|%5d|\n", stack[i]);
	}
	printf("|-----|\n");
	printf("\n");
}

int pop(void)
{
	if (sp <= 0) {
		printf("X^bNł\n");
		return 0;
	}

	return (stack[--sp]);
}

void push(int val)
{
	if (sp >= MAX) {
		printf("X^bNςł\n");
		return;
	}

	stack[sp++] = val;
}

int main(void)
{
	int val;

	push(3);
	push(5);
	show();
	push(13);
	show();

	val = pop();
	printf("ol: %d\n", val);
	show();

	return 0;
}

