/* 2002/12/21
 *
 * hd.c - u16i_vvOv
 *
 * Presented by YUTAKA
 */

#include <stdio.h>
#include <stdlib.h>


/* IvVϐ */
int gSkipMode = 0, gSkipBytes;   /* ItZbg */


/* _vCtH[}bg\ */
void disp_line(int addr, int *bytes, int byte_cnt)
{
	int i, c;

	/* 擪̃AhX\ */
	printf("%08X : ", addr);

	/* oCi\i4oCgƂɋ󔒂}j*/
	for (i = 0 ; i < byte_cnt ; i++) {
		if (i > 0 && i % 4 == 0)
			printf(" ");

		printf("%02X", bytes[i]);
	}

	/* ASCII\܂ł̋󔒂₤ */
	printf("   %*s%*s", (16-byte_cnt)*2+1, " ", (16-byte_cnt+3)/4, " ");

	/* ASCII\ */
	for (i = 0 ; i < byte_cnt ; i++) {
		c = bytes[i];
		if (c >= 0x20 && c <= 0x7f) {
			printf("%c", c);
		} else {
			printf(".");
		}
	}

	printf("\n");
}


/* _v[` */
void dump(FILE *fp)
{
	int c, addr;
	int bytes[16], *ptr;
	int byte_cnt;

	addr = 0;
	byte_cnt = 0;
	ptr = bytes;
	while ((c = fgetc(fp)) != EOF) {
		*ptr++ = c;
		byte_cnt++;

		if (byte_cnt == 16) {
			disp_line(addr, bytes, byte_cnt);

			addr += 16;
			byte_cnt = 0;
			ptr = bytes;
		}
	}

	if (byte_cnt > 0) {
		disp_line(addr, bytes, byte_cnt);
	}
}


/* R}hCwv̕\ */
void show_help(void)
{
	printf("===== 16i_vvO =====\n"
		   "Usage: hd [-o offset] [file]\n"
		   "Options:\n"
		   "   -o   \tw肵ItZbg_vJn܂\n"
		   "ȂŃR}hCwv\\n");
}


/* 𐔒lɕϊ */
int convert_string_to_number(char *str)
{
	char *e;
	int num;

	num = (int)strtol(str, &e, 0);
	if (*e) {
		printf("sȃItZbglwł (%s [%s])\n", str, e);
		exit(1);
	}

	return (num);
}


/* C֐ */
int main(int argc, char **argv)
{
	FILE *fp = NULL;

	/* R}hC */
	if (argc == 1) {
		show_help();
		exit(1);
	}

	while (argc > 1) {
		if (argv[1][0] == '-') {
			if (argv[1][1] == 'o') {
				if (argc < 3) {
					printf("-o̒ɃItZbgw肪Kvł\n");
					exit(1);
				}
				gSkipBytes = convert_string_to_number(argv[2]);
				gSkipMode = 1;

				argc--;
				argv++;

			} else {
				printf("sȃIvVwł (%s)\n", argv[1]);
				exit(1);
			}

		} else {
			/* łɊJĂt@CΕ */
			if (fp != NULL) {
				fclose(fp);
			}
			fp = fopen(argv[1], "rb");  /* oCi[hŊJ */
			if (fp == NULL) {
				printf("t@C `%s' J܂\n", argv[1]);
				exit(1);
			}
		}

		argc--;
		argv++;
	}

	/* t@C̃V[N */
	if (gSkipMode) {
		fseek(fp, gSkipBytes, SEEK_SET);
	}

	dump(fp);

	fclose(fp);

	return 0;
}

