/* 2002/12/24
 *
 * syogi.c      with Borland C++Compiler 5.5.1
 *                   Microsoft Visual C++ .NET
 *
 * upYv
 * (9~9)40̏̋ûAě؂
 *   Ȃ悤ɔzu邱Ƃ͂ł邾낤H@܂A
 *   zułꍇʂ̔Ֆʂ邩BȂA͍lȂ
 *   ̂ƂB
 *
 * Copyright (C)2002 YUTAKA
 * All rights reserved.
 */
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>

//#define NDEBUG    /* for assert() */
#include <assert.h>


/*
f[^\́AՂ̎ɕ2̕ǂA13~131z
ƂĈBՖʂփANZXƂ(x,y)=(2,2)`(10,10)
͈͂ōsB

@0 1 2 3 4 5 6 7 8 9 101112
@ 0
@ 1
@ 2
@ 3
@ 4
@ 5
@ 6
@ 7
@ 8
@ 9
@ 10
@ 11
@ 12

 */


#define RSIZE 9         /* Ղ̖{̃TCY */
#define SIZE (9 + 4)    /* ǂ܂߂Ղ̃TCY */
#define POS(x,y) ((x) + (y)*SIZE)

#define PIECE_NUM 40   /* ׂĂ̋̐ */
#define KIND_NUM  8    /* ̎ */

#define KAKU  'A'     /* p */
#define HISYA 'H'     /*  */
#define KEIMA 'M'     /* j */
#define YARI  'Y'     /*  */
#define OU    'O'     /*  */
#define KIN   'K'     /*  */
#define GIN   'G'     /*  */
#define FU    'F'     /*  */

#define WALL  'W'     /* ǂ̃}[N */

char *piece_name[256];

int board[SIZE * SIZE];   /* Ֆ */
int inhibit[SIZE * SIZE]; /* ؏ */

/* e[u */
typedef struct {
	char name;     /* ̖O */
	int count;     /* ̐ */
	int pos[8][2]; /* ؈ʒu */
	int posnum;    /* ؂̐ */
} piece_t;

/* ̏Fo^ƂȂ 
 * ԁpj⁨
 */
piece_t	pieces[KIND_NUM] = {
	{HISYA, 1*2, {{0,0},}, 0},
	{KAKU, 1*2, {{0,0},}, 0},
	{KEIMA, 2*2, {{-1,-2}, {1, -2}}, 2},
	{YARI, 2*2, {{0,0},}, 0},
	{OU, 1*2, {{-1,-1}, {0,-1}, {1,-1}, {-1,0}, {1,0}, {-1,1}, {0,1}, {1,1}}, 8},
	{KIN, 2*2, {{-1,-1}, {0,-1}, {1,-1}, {-1,0}, {1,0}, {0,1}}, 6},
	{GIN, 2*2, {{-1,-1}, {0,-1}, {1,-1}, {-1,1}, {1,1}}, 5},
	{FU, 9*2, {{0,-1},}, 1},
};

int use[KIND_NUM];  /* ̎gpς݃`FbNtO */
int ans_cnt;   /* ̐ */


/*-----------------------------------------------------------------
 * [`
 *-----------------------------------------------------------------
 */

/* Ֆʂ̕\ */
void disp(int *board)
{
	int x, y, c;

	for (y = 2 ; y < SIZE-2 ; y++) {
		for (x = 2 ; x < SIZE-2 ; x++) {
			c = board[POS(x,y)];
			if (c == 0) {
				printf("");
			} else if (c == WALL) {
				printf("WW");
			} else {
				printf("%s", piece_name[c]);
			}
		}
		printf("\n");
	}
	printf("\n");

#if 1
	/* ؂̕\ */
	for (y = 2 ; y < SIZE-2 ; y++) {
		for (x = 2 ; x < SIZE-2 ; x++) {
			printf("%2d", inhibit[POS(x,y)]);
		}
		printf("\n");
	}
	printf("\n");
#endif
}


int check_same_board(int *board)
{
#define RECMAX 1000
	static int record[RECMAX][SIZE * SIZE]; 
	static int reccnt = 0;
	int x, y, i, c;

	assert(reccnt < RECMAX);

	for (i = 0 ; i < reccnt ; i++) {
		for (y = 2 ; y < SIZE-2 ; y++) {
			for (x = 2 ; x < SIZE-2 ; x++) {
				c = POS(x,y);
				if (record[i][c] != board[c])
					goto skip;
			}
		}
		/* same */
		return 0;
skip:;
	}

	for (i = 0 ; i < reccnt ; i++) {
		for (y = 2 ; y < SIZE-2 ; y++) {
			for (x = 2 ; x < SIZE-2 ; x++) {
				if (record[i][POS(x,y)] != board[POS(SIZE-1-x,y)])
					goto skip2;
			}
		}
		/* same */
		return 0;
skip2:;
	}


	for (i = 0 ; i < SIZE*SIZE ; i++) {
		record[reccnt][i] = board[i];
	}
	reccnt++;

	return 1;
}


/* pEԁEȊŐu */
int do_etc(int kind, int x, int y, int flag)
{
	int px, py, dirs, i, c;

	dirs = pieces[kind].posnum;

	for (i = 0 ; i < dirs ; i++) {
		px = x + pieces[kind].pos[i][0];
		py = y + pieces[kind].pos[i][1];
		c = POS(px,py);

		if (board[c] == WALL)
			continue;

		if (flag == 0) {
			/* ؂ɋ邩ǂׂ */
			if (board[c] != 0) {
				return 0;     /* 邩_ */
			}

		} else if (flag == 1) {
			/* ؂Ƀ}[Nt */
			inhibit[c]++;

		} else {
			/* ؂}[NO */
			inhibit[c]--;

		}
	}

	return 1;   /* ؂ɒNȂ */
}


/* u */
int do_yari(int x, int y, int flag)
{
	static int dir[1][2] = {
		{0,-1}
	};
	int px, py, n, i, c;

	for (i = 0 ; i < 1 ; i++) {
		for (n = 1 ; n < RSIZE ; n++) {
			px = x + n * dir[i][0];
			py = y + n * dir[i][1];
			c = POS(px,py);

			if (board[c] == WALL)
				break;

			if (flag == 0) {
				/* ؂ɋ邩ǂׂ */
				if (board[c] != 0)
					return 0;

			} else if (flag == 1) {
				/* ؂Ƀ}[Nt */
				assert(board[POS(px,py)] == 0);

				inhibit[c]++;

			} else {
				/* ؂}[NO */
				inhibit[c]--;

			}
		}
	}

	return 1;   /* ؂ɒNȂ */
}


/* Ԃu */
int do_hisya(int x, int y, int flag)
{
	static int dir[4][2] = {
		{1,0}, {0,-1}, {-1,0}, {0,1},
	};
	int px, py, n, i, c;

	for (i = 0 ; i < 4 ; i++) {
		for (n = 1 ; n < RSIZE ; n++) {
			px = x + n * dir[i][0];
			py = y + n * dir[i][1];
			c = POS(px,py);

			if (board[c] == WALL)
				break;

			if (flag == 0) {
				/* ؂ɋ邩ǂׂ */
				if (board[c] != 0)
					return 0;

			} else if (flag == 1) {
				/* ؂Ƀ}[Nt */
				assert(board[POS(px,py)] == 0);

				inhibit[c]++;

			} else {
				/* ؂}[NO */
				inhibit[c]--;

			}
		}
	}

	return 1;   /* ؂ɒNȂ */
}


/* pu */
int do_kaku(int x, int y, int flag)
{
	static int dir[4][2] = {
		{1,1}, {1,-1}, {-1,1}, {-1,-1},
	};
	int px, py, n, i, c;

	for (i = 0 ; i < 4 ; i++) {   /* 4 */
		for (n = 1 ; n < RSIZE ; n++) {
			px = x + n * dir[i][0];
			py = y + n * dir[i][1];
			c = POS(px,py);

			if (board[c] == WALL)
				break;

			if (flag == 0) {
				/* ؂ɋ邩ǂׂ */
				if (board[c] != 0)
					return 0;

			} else if (flag == 1) {
				/* ؂Ƀ}[Nt */
				assert(board[POS(px,py)] == 0);

				inhibit[c]++;

			} else {
				/* ؂}[NO */
				inhibit[c]--;

			}
		}
	}

	return 1;   /* ؂ɒNȂ */
}


/* ؂łȂ}X𐔂 */
int get_empty_count(void)
{
	int x, y, c, n;

	n = 0;
	for (y = 2 ; y < SIZE - 2 ; y++) {
		for (x = 2 ; x < SIZE - 2 ; x++) {
			c = POS(x,y);
			if ((board[c] == 0 && inhibit[c] == 0))
				n++;
		}
	}
	return (n);
}


/* rest̋iAAAAju邩ǂׂ */
int is_putable(int rest)
{
	int x, y, c, n, px, py;

	/* uꏊ𐔂 */
	n = 0;
	for (y = 2 ; y < SIZE - 2 ; y++) {
		for (x = 2 ; x < SIZE - 2 ; x++) {
			c = POS(x,y);
			/* ؂łȂ}XT */
			if (!(board[c] == 0 && inhibit[c] == 0))
				continue;

			px = x;
			py = y - 1;
			c = POS(px, py);
			/* 1オǁC͌؂łȂ}XȂ */
			if (board[c] == WALL || board[c] == 0) {
				n++;
			}
		}
	}

	if (n == rest) {
		return 2;   /* ҂u */
	}
	if (n >= rest) {
		return 1;   /* ]TĒu */
	}

	return 0;  /* uȂ */
}


/* T[` */
void sub(int n)
{
	int i, x, y, c, kind, empty, rest, sameflag;
	int xmin, xmax, ymin, ymax;


	/* ׂĂ̋܂΁A */
	if (n >= PIECE_NUM) {
		ans_cnt++;

		printf(" No.%d\n", ans_cnt);
		disp(board);
		exit(1);

		return;
	}

	/* gp̋I */
	for (i = 0 ; i < KIND_NUM ; i++) {
		if (use[i] > 0)
			break;
	}
	if (i == KIND_NUM) {
		disp(board);
		exit(1);
		return;
	}

	kind = i;


	if (n == 4) {
		//disp(board); exit(1);
		if (check_same_board(board) == 0) {
			//disp(board); exit(1);
			return;
		}
	}


	//printf(" %d (%c / %s)\n", kind, pieces[kind].name, piece_name[pieces[kind].name]);

//	if (kind == 7) { disp(board); exit(1); }


	/* } */
	sameflag = -1;
#if 1
	rest = PIECE_NUM - n;      /* cĂ̐ */
	if (!(pieces[kind].name == HISYA ||
		pieces[kind].name == KAKU ||
		pieces[kind].name == KEIMA)) {

		if ((sameflag = is_putable(rest)) == 0) {
			return;
		}

	} else {
		empty = get_empty_count();
		/* }X̐CcĂ̂ق΁Cȏ
		 * ׂĂʁB
		 */
		if (empty < rest) {
			return;
		}
	}
#endif


#if 0
	/* T͈͂𐧖񂷂 */
	if (pieces[kind].name == KAKU) {
		xmin = 5; xmax = 7;
		ymin = ymax = SIZE - 3;
	} else if (pieces[kind].name == YARI) {
		xmin = 4; xmax = 7;
		ymin = ymax = 2;
	} else if (pieces[kind].name == HISYA) {
		xmin = 3; xmax = 9;
		ymin = 3; ymax = 5;
	} else if (pieces[kind].name == KEIMA) {
		xmin = 2; xmax = 7;
		ymin = 7; ymax = 10;
	} else {
		xmin = 2; xmax = SIZE - 3;
		ymin = 2; ymax = SIZE - 3;
	}
#else
	xmin = 2; xmax = SIZE - 3;
	ymin = 2; ymax = SIZE - 3;

#endif


	/* ՖʂŒuƂT */
	for (y = ymin ; y <= ymax ; y++) {
		for (x = xmin ; x <= xmax ; x++) {
			c = POS(x,y);

			/* ؂łȂ}XT */
			if (!(board[c] == 0 && inhibit[c] == 0))
				continue;

			/* u邩ǂ */
			/*** p ***/
			if (pieces[kind].name == KAKU) {
				if (do_kaku(x, y, 0)) {  /* u */
					do_kaku(x, y, 1);
					use[kind]--;
					board[POS(x,y)] = KAKU;

					sub(n + 1);

					board[POS(x,y)] = 0;
					use[kind]++;
					do_kaku(x, y, 2);
				}

			} else if (pieces[kind].name == HISYA) { /***  ***/
				if (do_hisya(x, y, 0)) {  /* u */
					do_hisya(x, y, 1);
					use[kind]--;
					board[POS(x,y)] = HISYA;

					sub(n + 1);

					board[POS(x,y)] = 0;
					use[kind]++;
					do_hisya(x, y, 2);
				}

			} else if (pieces[kind].name == YARI) { /***  ***/
				if (do_yari(x, y, 0)) {  /* u */
					do_yari(x, y, 1);
					use[kind]--;
					board[POS(x,y)] = YARI;

					sub(n + 1);

					board[POS(x,y)] = 0;
					use[kind]++;
					do_yari(x, y, 2);
				}

			} else {  /*** ̑ ***/
				if (do_etc(kind, x, y, 0)) {  /* u */
					do_etc(kind, x, y, 1);
					use[kind]--;
					board[POS(x,y)] = pieces[kind].name;

					sub(n + 1);

					board[POS(x,y)] = 0;
					use[kind]++;
					do_etc(kind, x, y, 2);

				} else {  /* (x,y)ɒuȂꍇ */

					/* 󂫏ꏊ̐ƎcꍇA1Jɂł
					 * uȂƂ́Aȍ~ׂĂʁB
					 */
					if (sameflag == 2) {
						return;
					}

				}
			}
		}
	}

	/* ǂɂuȂ߂ */
	return;
}


/* f[^\̏ */
void init(void)
{
	int i, x, y;

	/* Ֆʂƌ؂ */
	for (y = 0 ; y < SIZE ; y++) {
		for (x = 0 ; x < SIZE ; x++) {
			if (x <= 1 || x >= SIZE - 2 || y <= 1 || y >= SIZE - 2)
				board[POS(x,y)] = WALL;
			else
				board[POS(x,y)] = 0;

			inhibit[POS(x,y)] = 0;
		}
	}

	/* ̌Zbg */
	for (i = 0 ; i < KIND_NUM ; i++) {
		use[i] = pieces[i].count;
	}

	/* ̖ */
	piece_name[FU] = "";
	piece_name[OU] = "";
	piece_name[KIN] = "";
	piece_name[GIN] = "";
	piece_name[KEIMA] = "j";
	piece_name[YARI] = "";
	piece_name[KAKU] = "p";
	piece_name[HISYA] = "";

	/* ̌ */
	ans_cnt = 0;
}

/* C֐ */
int main(void)
{
	clock_t t = clock();

	init();
	sub(0);

    printf("time %.2f\n", (double)((clock() - t) / CLOCKS_PER_SEC));
	return 0;
}


