/* 2002/1/1
 *
 * graph.c - u_CNXg@ɂoHIv
 *
 * Presented by YUTAKA
 */
#include <stdio.h>

enum {
	A, B, C, D, 
	MAX,
	X = -1,
	INFINITE = 9999,
};

/*
           8
	AB
	_         _
	  _        
   3    _    2 1
	     5_     
	        _ ^
	DC
	       1
 */
int map[MAX][MAX] = {  /* oH */
	/* A  B  C  D */
	{  X, 8, 5, 3},  /* A */
	{  8, X, 1, X},  /* B */
	{  5, 2, X, 1},  /* C */
	{  3, X, 1, X},  /* D */
};

int dist[MAX];     /* e_ɂŒZ */
int visit[MAX];    /* e_̖KtO */


/* 2̍ŏl߂ */
int get_min(int a, int b)
{
	if (a < b)
		return (a);
	return (b);
}


/* C֐ */
int main(void)
{
	int i, j, next;

	/* ݒ */
	for (i = 0 ; i < MAX ; i++) {
		dist[i] = INFINITE;
		visit[i] = 0;
	}

	/* _CNXg@ɂoHTs */
	next = A;  /* A_JnƂ */
	dist[next] = 0;

	for (;;) {
		int min = INFINITE;
		int can_next = 0;

		for (j = 0 ; j < MAX ; j++) {
			if (map[next][j] != X) {  /* nextj ̃pX݂ */
				if (visit[j] == 1) /* łɖKς݂Ȃ牽Ȃ */
					continue;

				dist[j] = get_min(dist[j], dist[next] + map[next][j]);

				/* nextj̃pXɂāCoHŏƂȂ̂oĂ */
				if (dist[j] < min) {
					min = dist[j];
					can_next = j;
				}
			}
		}
		if (min == INFINITE)   /* pX1ȂȂΒTI */
			break;

		visit[next] = 1;  /* KtO𗧂Ă */
		printf("%c -> ", 'A' + next);
		next = can_next;
	}
	printf("I[\n");

	/* ŒZoH̕\ */
	for (i = 0 ; i < MAX ; i++) {
		printf("_ %c = %d\n", 'A' + i, dist[i]);
	}

	return 0;
}

