/*
 * ring.c - uOobt@v
 *
 */
#include <stdio.h>

#define MAX 100
int ring[MAX];
int head, tail, count;

/* Oobt@̓e\ */
void show(void)
{
	int i, n;

	n = head;
	printf("|");
	for (i = 0; i < count ; i++) {
		printf("%d ", ring[n]);
		n++;
		n %= MAX;
	}
	printf("|\n");
}

/* Oobt@f[^o */
int dequeue(void)
{
	int ret;

	if (count <= 0) {
		printf("L[ł\n");
		return 0;
	}

	ret = ring[head++];
	head %= MAX;
	count--;

	return (ret);
}


/* Oobt@Ƀf[^i[ */
void enqueue(int val)
{
	if (count >= MAX) {
		printf("L[ςł\n");
		return;
	}

	ring[tail++] = val;
	tail %= MAX;
	count++;
}

/* Oobt@̏ */
void init(void)
{
	head = tail = 0;
	count = 0;
}

int main(void)
{
	int val;

	enqueue(13);
	enqueue(8);
	show();
	enqueue(6);
	show();

	val = dequeue();
	printf("ol: %d\n", val);
	show();

	return 0;
}

