/*
 * maze.c - u{ZpҎ@13NHov
 */
#include <stdio.h>
#include <stdlib.h>

#define UP        0
#define RIGHT     1
#define DOWN      2
#define LEFT      3
#define ROAD      0x00   /* ̃R[h */
#define WALL      0xff   /* ǂ̃R[h */
#define SMAX      8
#define ENTRANCE  0xf0   /* n_̃R[h */
#define EXIT      0xf1   /* I_̃R[h */

int rcheck(void);
int fcheck(void);
void go(void);
void maze(void);

int x, y, dir;

/* Hf[^ */
int M[SMAX][SMAX] = {
	WALL, ENTRANCE, WALL, WALL, WALL, WALL, WALL, WALL, 
	WALL, ROAD,     ROAD, ROAD, ROAD, WALL, ROAD, WALL,
	WALL, ROAD,     WALL, ROAD, WALL, WALL, ROAD, WALL,
	WALL, ROAD,     WALL, ROAD, WALL, ROAD, ROAD, WALL,
	WALL, ROAD,     WALL, ROAD, ROAD, ROAD, WALL, WALL,
	WALL, WALL,     WALL, ROAD, WALL, ROAD, WALL, WALL,
	WALL, ROAD,     ROAD, ROAD, WALL, ROAD, ROAD, WALL, 
	WALL, WALL,     WALL, WALL, WALL, WALL, EXIT, WALL, 
};


/* H}̕`iVKǉj */
void show_maze(void)
{
	char *dirs[] = {"", "", "", ""};
	int nx, ny, c;

	for (ny = 0 ; ny < SMAX ; ny++) {
		for (nx = 0 ; nx < SMAX ; nx++) {
			c = M[ny][nx];

			if (x == nx && y == ny) {
				printf("%s", dirs[dir]);
			} else if (c == WALL) {
				printf("");
			} else {
				printf("");
			}
		}
		printf("\n");
	}
	printf("\n");
}


/* HT[` */
void maze(void)
{
	/* oɂԂ܂ */
	while ( M[y][x] != EXIT ) {
		printf("dir=%d y=%d x=%d\n", dir, y, x);
		show_maze();

		if ( ( rcheck() == ROAD ) ||
			 ( rcheck() == EXIT ) ) {  /* Eɓ */
			dir = ( dir + 1 ) % 4;
			go();  /* i */
		}
		else if ( ( fcheck() == ROAD ) ||   /* Oiɓ */
				  ( fcheck() == EXIT ) ) go();
	    else dir = ( dir + 3 ) % 4;    /* Ȃ΁C90x] */
	}

	printf("dir=%d y=%d x=%d\n", dir, y, x);
	show_maze();

	return;
}

/* E@ɂ铹̃`FbN */
int rcheck(void)
{
	if      ( dir == UP )    return M[y][x+1];
	else if ( dir == RIGHT ) return M[y+1][x];
	else if ( dir == DOWN )  return M[y][x-1];
	else                     return M[y-1][x];
}

/* @ɂ铹̃`FbN */
int lcheck(void)
{
	if      ( dir == UP )    return M[y][x-1];
	else if ( dir == RIGHT ) return M[y-1][x];
	else if ( dir == DOWN )  return M[y][x+1];
	else                     return M[y+1][x];
}

/* Ă铹̃`FbN */
int fcheck(void)
{
	if      ( dir == UP )    return M[y-1][x];
	else if ( dir == RIGHT ) return M[y][x+1];
	else if ( dir == DOWN )  return M[y+1][x];
	else                     return M[y][x-1];
}

/* is */
void go(void)
{
	if      ( dir == UP )    y--;
	else if ( dir == RIGHT ) x++;
	else if ( dir == DOWN )  y++;
	else                     x--;
}


/* C֐ */
int main(void)
{
	/* ݒ */
	x = 1;
	y = 0;
	dir = DOWN;

	maze();

	return 0;
}


