#define UP        0
#define RIGHT     1
#define DOWN      2
#define LEFT      3
#define ROAD      0x00   /* ̃R[h */
#define WALL      0xff   /* ǂ̃R[h */
#define SMAX      8
#define ENTRANCE  0xf0   /* n_̃R[h */
#define EXIT      0xf1   /* I_̃R[h */

int rcheck(void);
int fcheck(void);
void go(void);
void maze(void);

int M[SMAX][SMAX], x, y, dir;

void maze()
{
	while ( M[y][x] != EXIT ) {
		if ( ( rcheck() == ROAD ) ||
			 ( rcheck() == EXIT ) ) {
			dir = ( dir + 1 ) % 4;
			go();
		}
		else if ( ( fcheck() == ROAD ) ||
				  ( fcheck() == EXIT ) ) go();
	    else dir = ( dir + 3 ) % 4;
	}
	return;
}

int rcheck()
{
	if      ( dir == UP )    return M[y][x+1];
	else if ( dir == RIGHT ) return M[y+1][x];
	else if ( dir == DOWN )  return M[y][x-1];
	else                     return M[y-1][x];
}

int fcheck()
{
	if      ( dir == UP )    return M[y-1][x];
	else if ( dir == RIGHT ) return M[y][x+1];
	else if ( dir == DOWN )  return M[y+1][x];
	else                     return M[y][x-1];
}

void go()
{
	if      ( dir == UP )    y--;
	else if ( dir == RIGHT ) x++;
	else if ( dir == DOWN )  y++;
	else                     x--;
}


